<?php
require("common.php");
include("function.php");

/* $Id: tbl_dump.php,v 1.8 2000/02/13 20:15:56 tobias Exp $ */
@set_time_limit(600);
$crlf="\n";

if(empty($asfile)) 
{ 
    //include("header.inc.php");
    print "<div align=left><pre>\n";
}
else
{
    //include("lib.inc.php");
    $ext = "sql";
    if($what == "csv")
        $ext = "csv";
    header("Content-disposition: filename=$table.$ext");
	header("Content-type: application/octetstream");
	header("Pragma: no-cache");
	header("Expires: 0");
	
    // doing some DOS-CRLF magic...
	$client=getenv("HTTP_USER_AGENT");
	if(ereg('[^(]*\((.*)\)[^)]*',$client,$regs)) 
    {
	    $os = $regs[1];
        // this looks better under WinX
        if (eregi("Win",$os)) 
            $crlf="\r\n";
	}
}

// Return $table's CREATE definition
// Returns a string containing the CREATE statement on success
function get_table_def($db, $table, $crlf)
{
    global $drop;

    $schema_create = "";
    if(!empty($drop))
        $schema_create .= "DROP TABLE IF EXISTS $table;$crlf";

    $schema_create .= "CREATE TABLE $table ($crlf";

    //$result = mysql_db_query($db, "SHOW FIELDS FROM $table") or mysql_die();
    
    $result = runquery("SHOW FIELDS FROM $table");
    
    while($row = mysql_fetch_array($result))
    {
        $schema_create .= "   $row[Field] $row[Type]";

        if(isset($row["Default"]) && (!empty($row["Default"]) || $row["Default"] == "0"))
            $schema_create .= " DEFAULT '$row[Default]'";
        if($row["Null"] != "YES")
            $schema_create .= " NOT NULL";
        if($row["Extra"] != "")
            $schema_create .= " $row[Extra]";
        $schema_create .= ",$crlf";
    }
    $schema_create = ereg_replace(",".$crlf."$", "", $schema_create);
    $result = mysql_db_query($db, "SHOW KEYS FROM $table") or mysql_die();
    while($row = mysql_fetch_array($result))
    {
        $kname=$row['Key_name'];
        if(($kname != "PRIMARY") && ($row['Non_unique'] == 0))
            $kname="UNIQUE|$kname";
         if(!isset($index[$kname]))
             $index[$kname] = array();
         $index[$kname][] = $row['Column_name'];
    }

    while(list($x, $columns) = @each($index))
    {
         $schema_create .= ",$crlf";
         if($x == "PRIMARY")
             $schema_create .= "   PRIMARY KEY (" . implode($columns, ", ") . ")";
         elseif (substr($x,0,6) == "UNIQUE")
            $schema_create .= "   UNIQUE ".substr($x,7)." (" . implode($columns, ", ") . ")";
         else
            $schema_create .= "   KEY $x (" . implode($columns, ", ") . ")";
    }

    $schema_create .= "$crlf)";
    return (stripslashes($schema_create));
}

// Get the content of $table as a series of INSERT statements.
// After every row, a custom callback function $handler gets called.
// $handler must accept one parameter ($sql_insert);
function get_table_content($db, $table, $handler)
{
    //$result = mysql_db_query($db, "SELECT * FROM $table") or mysql_die();
    $result = runquery("SELECT * FROM $table");
    $i = 0;
    while($row = mysql_fetch_row($result))
    {
        //set_time_limit(60); // HaRa
        $table_list = "(";

        for($j=0; $j<mysql_num_fields($result);$j++)
            $table_list .= mysql_field_name($result,$j).", ";

        $table_list = substr($table_list,0,-2);
        $table_list .= ")";

        if(isset($GLOBALS["showcolumns"]))
            $schema_insert = "INSERT INTO $table $table_list VALUES (";
        else
            $schema_insert = "INSERT INTO $table VALUES (";

        for($j=0; $j<mysql_num_fields($result);$j++)
        {
            if(!isset($row[$j]))
                $schema_insert .= " NULL,";
            elseif($row[$j] != "")
                $schema_insert .= " '".addslashes($row[$j])."',";
            else
                $schema_insert .= " '',";
        }
        $schema_insert = ereg_replace(",$", "", $schema_insert);
        $schema_insert .= ")";

        $schema_insert = str_replace("\n","", $schema_insert);   // get rid of extra enters
        $schema_insert = str_replace("\r","", $schema_insert);        

        $handler(trim($schema_insert));
        
        $i++;
    }
    return (true);
}

// Get the content of $table as a CSV output.
// $sep contains the separation string.
// After every row, a custom callback function $handler gets called.
// $handler must accept one parameter ($sql_insert);
function get_table_csv($db, $table, $sep, $handler)
{
    //$result = mysql_db_query($db, "SELECT * FROM $table") or mysql_die();
    $result = runquery("SELECT * FROM $table");
    
    $i = 0;
    while($row = mysql_fetch_row($result))
    {
        //set_time_limit(60); // HaRa
        $schema_insert = "";
        for($j=0; $j<mysql_num_fields($result);$j++)
        {
            if(!isset($row[$j]))
                $schema_insert .= "NULL".$sep;
            elseif ($row[$j] != "")
                $schema_insert .= "$row[$j]".$sep;
            else
                $schema_insert .= "".$sep;
        }
        $schema_insert = str_replace($sep."$", "", $schema_insert);
        $schema_insert = str_replace("\n","", $schema_insert);   // get rid of extra enters
        $schema_insert = str_replace("\r","", $schema_insert);        
        $handler(trim($schema_insert));
        $i++;
    }
    return (true);
}

function my_handler($sql_insert)
{
    global $crlf, $asfile;
    if(empty($asfile))
        echo htmlspecialchars("$sql_insert;$crlf");
    else
        echo "$sql_insert;$crlf";
}
 
function my_csvhandler($sql_insert)
{
    global $crlf, $asfile;
    if(empty($asfile))
        echo htmlspecialchars("$sql_insert;$crlf");
    else
        echo "$sql_insert;$crlf";
}

if($what != "csv") 
{
    print "# DVD Database Project $version [MySQL-Dump]$crlf";
    print "# http://sourceforge.net/projects/dvddbp/$crlf";
    print "#$crlf";
    print "# Host: " . $dbhost; 

    print " Database: $db$crlf";
    print "# Backup log generated: ".date("l, F jS Y, h:iA").$crlf;
    print "# -------------------------------------------------------------$crlf";
    print "$crlf#$crlf";
    print "# Table structure for '$table'$crlf";
    print "#$crlf$crlf";

    print get_table_def($db, $table, $crlf).";$crlf";

    if($what == "data")
    {
	print "$crlf#$crlf";
        print "# Dumping data for table '$table'$crlf"; 
        print "#$crlf$crlf";

        get_table_content($db, $table, "my_handler");
    }
} 
else 
{ // $what != "csv"
  	get_table_csv($db, $table, $separator, "my_csvhandler");
}

if(empty($asfile))
{
    print "</pre></div>\n";
    //include ("footer.inc.php");
}
?>
